#include "claseVerIns.h"

claseVerIns::claseVerIns(QWidget *parent=0, char *name=0)
                             : QDialog(parent,name,FALSE,0)
{
        QString s;

        s="K ModBox - ";
        s+=i18n("Samples info");
        setCaption(s);

        ins = new KTabListBox(this,"ins", 8);
        ins->setSeparator('\t');
        ins->setColumn(0,i18n("Name"),200);
        ins->setColumn(1,i18n("Bits"),25);
        ins->setColumn(2,i18n("Size"),60);
        ins->setColumn(3,i18n("Base speed"),60);
        ins->setColumn(4,i18n("Volume"),50);
        ins->setColumn(5,i18n("Panning"),50);
        ins->setColumn(6,i18n("Loop start"),60);
        ins->setColumn(7,i18n("Loop end"),60);

        setGeometry(30,30,ins->totalWidth()+20,200);
}

claseVerIns::~claseVerIns()
{
        delete ins;
}

void claseVerIns::cargar_ins(MODULE *modulo)
{
        int samp;
        QString s;
        QString n;
        ULONG aux=1;

        /* borrar la lista anterior */
        ins->setAutoUpdate( FALSE );
        ins->clear();
        /* cargar la nueva */
        for (samp=0; samp < modulo->numsmp; samp++)
        {
            if (modulo->samples[samp].samplename[0]!='\0')
               s=modulo->samples[samp].samplename;
            else
               s=" ";
            s+='\t';
            if ( modulo->samples[samp].flags & SF_16BITS )
            {
                s+="16";
                aux=2;
            }
            else
            {
                s+="8";
                aux=1;
            }
            s+='\t';
            n.setNum(modulo->samples[samp].length *  aux);
            s+=n;
            if ( (modulo->samples[samp].length * aux) != 0 )
            {
                s+='\t';
                n.setNum(modulo->samples[samp].speed);
                s+=n;
                s+='\t';
                n.setNum(modulo->samples[samp].volume);
                s+=n;
                s+='\t';
                n.setNum(modulo->samples[samp].panning);
                s+=n;
                s+='\t';
                n.setNum(modulo->samples[samp].loopstart *  aux);
                s+=n;
                s+='\t';
                n.setNum(modulo->samples[samp].loopend *  aux);
                s+=n;
            }
            /* Insertar! */
            ins->insertItem(s);
        }
        ins->setAutoUpdate( TRUE );
        ins->repaint();
}

void claseVerIns::mostrar( bool ver)
/* ver==TRUE? => mostrar, sino: ocultar */
{
        if ( ver && (this->isVisible()==FALSE) )
           this->show();
        else
        {
           if ( (ver==FALSE) && (this->isVisible()==TRUE) )
              this->hide();
        }
}

void claseVerIns::resizeEvent( QResizeEvent *r)
{
        QSize tam;
        tam=r->size();
        ins->setGeometry( 0, 0, tam.width(), tam.height());
}

void claseVerIns::closeEvent( QCloseEvent *e)
{
        emit ocultar_ins();
        e->accept();
}

#include "claseVerIns.moc"
