#include "modBoxConf.h"

modBoxConf::modBoxConf(QWidget *parent, char *name) 
	: QTabDialog(parent,name,TRUE,WStyle_DialogBorder )
{
   setCaption(i18n("K ModBox Configuration"));

   addTab( sound(), i18n("Sound options" ));
   addTab( general(), i18n("General"));

   setCancelButton( i18n("&Cancel") );
//   connect( this, SIGNAL(cancelButtonPressed()), SLOT(cancelar()) );
   setOkButton( i18n("&Ok" ));
//   connect( this, SIGNAL(okButtonPressed()), SLOT(aceptar()) );
   setApplyButton( i18n("&Apply" ));
   connect( this, SIGNAL(applyButtonPressed()), SLOT(guardar_config()) );
}

QWidget *modBoxConf::sound()
{
   QWidget *base = new QWidget( this, "sound" );

   QBoxLayout *l = new QVBoxLayout(base,10,0);

   bits16 = new QCheckBox(base, "bits16");
   bits16->setText(i18n("16 bits"));
   QToolTip::add(bits16,i18n("8/16 bits sound quality"));
   bits16->setMinimumSize( bits16->sizeHint() );
   l->addWidget( bits16 );

   stereo = new QCheckBox(base, "stereo");
   stereo->setText(i18n("Stereo"));
   stereo->setMinimumSize( stereo->sizeHint() );
   QToolTip::add(stereo,i18n("Mono/Stereo sound"));
   l->addWidget( stereo );
   
   label_sep = new QLabel(base, "label_sep");
   label_sep->setText(i18n("Stereo separation:"));
   label_sep->setMinimumSize( label_sep->sizeHint() );
   
   label_sepl = new QLabel(base, "label_sepl");
   label_sepl->setText(i18n("Off"));
   label_sepl->setFixedSize( label_sepl->sizeHint() );
   
   label_seph = new QLabel(base, "label_seph");
   label_seph->setText(i18n("Max"));
   label_seph->setFixedSize( label_seph->sizeHint() );
   
   separation = new QSlider(base, "separation");
   separation->setRange(0,16);
   separation->setSteps(1,4);
   separation->setOrientation(QSlider::Horizontal);
//   reverb->setMinimumSize(200,55,63,18);
   separation->setTickmarks( QSlider::Right );
   separation->setMinimumSize( separation->sizeHint() );
//   QToolTip::add(separation,i18n("Try this!"));

   QBoxLayout *l3 = new QHBoxLayout();
   l->addLayout(l3);
   l3->addWidget( label_sep );
   l3->addWidget( label_sepl );
   l3->addSpacing( 10 );
   l3->addWidget( separation );
   l3->addSpacing( 10 );
   l3->addWidget( label_seph );

   reverse_stereo = new QCheckBox(base, "reverse_stereo");
   reverse_stereo->setText(i18n("Reverse stereo"));
   reverse_stereo->setMinimumSize( reverse_stereo->sizeHint() );
   QToolTip::add(reverse_stereo,i18n("Exchanges the left/right stereo channels"));
   l->addWidget( reverse_stereo );

   filtro = new QCheckBox(base, "filtro");
   filtro->setText(i18n("Filter"));
   filtro->setMinimumSize( filtro->sizeHint() );
   QToolTip::add(filtro,i18n("Dynamic filter for improved sound quality"));
   l->addWidget( filtro );
   
   surround = new QCheckBox(base, "surround");
   surround->setText(i18n("Surround"));
   surround->setMinimumSize( surround->sizeHint() );
   QToolTip::add(surround,i18n("Surround sound enabled/disabled"));
   l->addWidget( surround );

   labelfrec = new QLabel(base, "labelfrec");
   labelfrec->setText(i18n("Mixing rate:"));
   labelfrec->setMinimumSize( labelfrec->sizeHint() );
   
   frecuencia = new QComboBox((bool)0,base,"frecuencia");
   frecuencia->setAutoResize(FALSE);
   frecuencia->setMaxCount(3);
   QToolTip::add(frecuencia,i18n("Mixing rate"));
   /* llenar el combo-box */
   frecuencia->insertItem( "11025 Hz",-1);
   frecuencia->insertItem( "22050 Hz",-1);
   frecuencia->insertItem( "44100 Hz",-1);
   frecuencia->setMinimumSize( frecuencia->sizeHint() );
   QBoxLayout *l1 = new QHBoxLayout();
   l->addLayout(l1);
   l1->addWidget( labelfrec );
   l1->addWidget( frecuencia );

//   l1->addSpacing(20);

   label_s_s = new QLabel(base, "label_s_s");
   label_s_s->setText(i18n("Reverb effect:"));
   label_s_s->setMinimumSize( label_s_s->sizeHint() );
   
   label_ssl = new QLabel(base, "label_ssl");
   label_ssl->setText(i18n("Off"));
   label_ssl->setFixedSize( label_ssl->sizeHint() );
   
   label_ssh = new QLabel(base, "label_ssh");
   label_ssh->setText(i18n("Max"));
   label_ssh->setFixedSize( label_ssh->sizeHint() );
   
   reverb = new QSlider(base, "reverb");
   reverb->setRange(0,15);
         	reverb->setValue(0);
   reverb->setSteps(1,4);
   reverb->setOrientation(QSlider::Horizontal);
//   reverb->setMinimumSize(200,55,63,18);
   reverb->setTickmarks( QSlider::Right );
   reverb->setMinimumSize( reverb->sizeHint() );
   QToolTip::add(reverb,i18n("Try this!"));

   QBoxLayout *l2 = new QHBoxLayout();
   l->addLayout(l2);
   l2->addWidget( label_s_s );
   l2->addWidget( label_ssl );
   l2->addSpacing( 10 );
   l2->addWidget( reverb );
   l2->addSpacing( 10 );
   l2->addWidget( label_ssh );
   
   l->activate();
   return base;
}

QWidget *modBoxConf::general()
{
   QWidget *base = new QWidget( this, "general" );

   QBoxLayout *l = new QVBoxLayout(base, 10, 0);

   labeldir = new QLabel(base, "labeldir");
   labeldir->setText(i18n("Initial directory:"));
   labeldir->setFixedSize( labeldir->sizeHint() );
   
   directorio = new QLineEdit(base, "directorio");
   directorio->setMinimumSize( directorio->sizeHint() );
   QToolTip::add(directorio,i18n("Initial directory for the Mods searching"));

   QBoxLayout *l1 = new QHBoxLayout();
   l->addLayout(l1);
   l1->addWidget( labeldir );
   l1->addWidget( directorio );
   
   repetir = new QCheckBox(base, "repetir");
   repetir->setText(i18n("Repeat"));
   repetir->setMinimumSize( repetir->sizeHint() );
   QToolTip::add(repetir,i18n("Repeat module at end"));
   l->addWidget( repetir );

   l->addStretch(1);

   l->activate();
   return base;
}

void modBoxConf::te_doy_conf()
{
        /* obtener los parmetros de configuracin */
        kde_config=kapp->getConfig();
	iniciar_displays();
        this->exec();
}

void modBoxConf::iniciar_displays()
{
	/* opciones de sonido */
	kde_config->setGroup("sound");
	stereo->setChecked( kde_config->readBoolEntry("stereo") );
        separation->setValue( kde_config->readNumEntry("separation") );
        reverse_stereo->setChecked( kde_config->readBoolEntry("reverse") );
        bits16->setChecked( kde_config->readBoolEntry("16bits") );
        filtro->setChecked( kde_config->readBoolEntry("filter") );
        surround->setChecked( kde_config->readBoolEntry("surround") );
	switch (kde_config->readNumEntry("frequency"))
	{
		case 11025: frecuencia->setCurrentItem( 0 ); break;
		case 22050: frecuencia->setCurrentItem( 1 ); break;
		case 44100: frecuencia->setCurrentItem( 2 ); break;
	}
        reverb->setValue( kde_config->readNumEntry("reverb") );
	
	/* Generales */
	kde_config->setGroup("general");
	directorio->setText( kde_config->readEntry("directory") );
        repetir->setChecked( kde_config->readBoolEntry("repeat") );
}

void modBoxConf::guardar_config()
{
 	/**** Guardar configuracion ****/
        /* opciones de sonido */
        kde_config->setGroup("sound");
        kde_config->writeEntry("stereo", stereo->isChecked() );
        kde_config->writeEntry("separation", separation->value() );
        kde_config->writeEntry("reverse", reverse_stereo->isChecked() );
        kde_config->writeEntry("16bits", bits16->isChecked() );
        kde_config->writeEntry("filter", filtro->isChecked() );
        kde_config->writeEntry("surround", surround->isChecked() );
        switch ( frecuencia->currentItem() )
	{
		case 0: kde_config->writeEntry("frequency", 11025); break;
		case 1: kde_config->writeEntry("frequency", 22050); break;
		case 2: kde_config->writeEntry("frequency", 44100); break;
	}
        kde_config->writeEntry("reverb", reverb->value() );

        /* general */
        kde_config->setGroup("general");
        kde_config->writeEntry("directory", directorio->text() );
        kde_config->writeEntry("repeat", repetir->isChecked() );

        kde_config->sync();

        emit conf_cambiada();
}

# include "modBoxConf.moc"
